*****************************************
*
*  ADDA.ASM
*  Ansterung fr AD- und DA-Wandler 
*  Invertierung von Eingangssignalen
*
*****************************************
	opt c,l


*AD-Wandler
addata	equ $08	;Datenregister
adstat	equ $09	;Status/Control

*DA-Wandler
misc	equ $0C	;Ausgaberate
plma	equ $0A	;PLM A
plmb	equ $0B	;PLM B

*Variablenspeicher im RAM
ADC	equ $0A1	;AD-Kanal

	org $101	;Startadresse

Init:	lda #0	;PLM-Kanaele, schnell
	sta misc

Loop:	lda #0	;Kanal 0
	sta ADC	;speichern
	jsr RdAD	;messen
	coma		;invertieren
	sta plma	;Ausgabe an PWM A

	lda #1	;Kanal 1
	sta ADC	;speichern
	jsr RdAD	;messen
	coma		;invertieren
	sta plmb	;Ausgabe an PWM B

	bra Loop	

RdAD	lda	#$20 		;AD-Wandler aktiv
	ADD	ADC		;plus Kanal
	sta	adstat		;Wandlung starten
Wait	brclr	7,adstat,Wait	;warten bis fertig
	lda	addata		;Ergebnis lesen
	rts
	end
	

