*****************************************
*
*  RS232 mit 9600 Baud     SERIO.ASM
*  Ausgabe auf Port B
*  Eingabe von Port C
*
*****************************************
	opt c,l,cre
* Ports
portb   equ $01	;Daten Port B (Port1...8)	 
portc   equ $02	;Daten Port C (Port9...16)	 
pbdir   equ $05	;Datenrichtung Port B
pcdir   equ $06	;Datenrichtung Port C  

* Serielle Schnittstelle
brate	equ $0D	;SCR-Baudrate 	
sccr1	equ $0E	;Controlregister 1
sccr2	equ $0F	;Controlregister 2
scsr	equ $10	;Status-Register
scdat	equ $11	;Datenregister


	org $101	;Startadresse im C-Control

Init:	lda #$FF
	sta pbdir	;P1...8 Ausgnge
	lda #0	;zuruecksetzen
	sta portb
	lda #$C0	;9600 Baud
	sta brate
	lda #$00	;Ohne Interrupts
	sta sccr1
	lda #$0C	;RxD und TxD freigeben
	sta sccr2

Loop:	jsr RdCOM	;Byte empfangen
	sta portb	;Byte ausgeben
	lda portc	;Ports 9...16 lesen
	jsr WrCOM	;Byte senden
	bra Loop 	;Schleife

RdCOM:	brclr 5,scsr,RdCOM	;Empfang?
	lda scdat		;Daten lesen
	rts

WrCOM:	brclr 7,scsr,WrCOM	;bereit?
	sta scdat		;Daten schreiben
	rts

	end


