'**************************************
'
' C-Control/BASIC        MORSEN2.BAS
'
' Aufgabe:
'
' - Morse-Empfang und Dekodierung
' - Taste an Port 8, 60 BpM
' - Ausgabe ans LCD-Display
'
'**************************************
' --- Definitionen --------------------

define lcd_port byteport[2]
define lcd_rs port[14]
define lcd_rw port[13]
define lcd_e port[15]
define lcd_buf byte
define lcd_param byte

define Taste port[8]
define Muster byte
define Zeit byte
define Zeichen byte
define Nr byte
define Zeile byte

' --- Programmoperationen -------------


  gosub LCD_INIT
  pause 10
  Zeile = 1
  Nr = 1
#Loop
  #Zeichenanfang
  Muster = 1
  wait not(Taste)
  #Punktstrich Zeit = 0
  #An
    Beep 400,1,0
    Zeit = Zeit + 1
    if not (Taste) then goto AN
  Muster = Muster shl 1
  if Zeit > 10 then Muster = Muster + 1
  Zeit = 0
  #Aus
    Pause 1
    Zeit = Zeit + 1
    if Zeit > 10 then goto Dekoder
    if not (Taste) then goto Punktstrich
    goto Aus
  #Zeichenpause
    Zeit = Zeit + 1
    if Zeit > 20 then goto Wortpause
    pause 1
    if not (Taste) then goto loop
    goto Zeichenpause
  #Wortpause
    put 32
    lcd_param = 32
    gosub LCD_WRITECHAR
    Nr = Nr + 1
    if Nr > 16 then gosub Zeilenwechsel
    goto Loop
  #Dekoder
    looktab Bitmuster, Muster, Zeichen
    put Zeichen
    lcd_param = Zeichen
    gosub LCD_WRITECHAR
    Nr = Nr + 1
    if Nr > 16 then gosub Zeilenwechsel
    goto Zeichenpause
end

#Zeilenwechsel
  Zeile = Zeile + 1
  if Zeile = 3 then Zeile = 1
  lcd_param = Zeile
  gosub LCD_GOTOLINE        
  Nr = 1
return


'*** LCD_Interface ***

#LCD_INIT

' alle ports 0
  lcd_port = OFF

' 8-Bit-Modus aktivieren
  lcd_param=&H38 : gosub LCD_WRITECMD

' mit 8-Bit-Command in 4-Bit-Modus umschalten
  lcd_port=&B00000010
  tog lcd_e
  tog lcd_e

' ab jetzt 4-Bit-Modus
  lcd_param = &H28 : gosub LCD_WRITECMD
  lcd_param = &H0C : gosub LCD_WRITECMD

' Display loeschen
#LCD_CLS
  lcd_param = &H02 : gosub LCD_WRITECMD
  lcd_param = &H01 : gosub LCD_WRITECMD
return

' Zeilenwechsel
#LCD_GOTOLINE
  if lcd_param = 1 then lcd_param = &H80
  if lcd_param = 2 then lcd_param = &HC0
  goto LCD_WRITECMD

' LCD-Kommando
#LCD_WRITECMD
  lcd_buf = OFF
  goto LCD_WRITE

' Zeichenausgabe
#LCD_WRITECHAR
  lcd_buf = &B00100000

' Kommando oder Zeichen an Display senden
#LCD_WRITE
  lcd_port = lcd_buf or (lcd_param shr 4) ' Hi-Nibble
  tog lcd_e
  tog lcd_e
  lcd_port = lcd_buf or (lcd_param and &H0F)  ' Lo-Nibble
  tog lcd_e
  tog lcd_e
return

end

table Bitmuster
32 32 69 84 73 65 78 77 83 85 82 87 68 75 71 79
72 86 70 32 76 32 80 74 66 88 67 89 90 81 32 32
53 52 32 51 32 32 32 50 32 32 32 32 32 32 32 49
54 32 32 32 32 32 32 32 55 32 32 32 56 32 57 48
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
tabend

' "0",  ----- , 00111111, Stelle 63, ASCII 48
' "1",  .---- , 00101111, Stelle 47, ASCII 49
' "2",  ..--- , 00100111, Stelle 39, ASCII 50
' "3",  ...-- , 00100011, Stelle 35, ASCII 51
' "4",  ....- , 00100001, Stelle 33, ASCII 52
' "5",  ..... , 00100000, Stelle 32, ASCII 53
' "6",  -.... , 00110000, Stelle 48, ASCII 54
' "7",  --... , 00111000, Stelle 56, ASCII 55
' "8",  ---.. , 00111100, Stelle 60, ASCII 56
' "9",  ----. , 00111110, Stelle 62, ASCII 57
' "A",     .- , 00000110, Stelle 6,  ASCII 65
' "B",   -... , 00011000, Stelle 24, ASCII 66
' "C",   -.-. , 00011010, Stelle 26, ASCII 67
' "D",    -.. , 00001100, Stelle 12  ASCII 68
' "E",      . , 00000010, Stelle 2,  ASCII 69
' "F",   ..-. , 00010010, Stelle 18, ASCII 70
' "G",    --. , 00001110, Stelle 14, ASCII 71
' "H",   .... , 00010000, Stelle 16, ASCII 72
' "I",     .. , 00000100, Stelle 4,  ASCII 73
' "J",   .--- , 00010111, Stelle 23, ASCII 74
' "K",    -.- , 00001101, Stelle 13, ASCII 75
' "L",   .-.. , 00010100, Stelle 20  ASCII 76
' "M",     -- , 00000111, Stelle 7,  ASCII 77
' "N",     -. , 00000110, Stelle 6,  ASCII 78
' "O",    --- , 00001111, Stelle 15, ASCII 79
' "P",   .--. , 00010110, Stelle 22, ASCII 80
' "Q",   --.- , 00011101, Stelle 30  ASCII 81
' "R",    .-. , 00001010, Stelle 10, ASCII 82
' "S",    ... , 00001000, Stelle 8,  ASCII 83
' "T",      - , 00000011, Stelle 3,  ASCII 84
' "U",    ..- , 00001001, Stelle 9,  ASCII 85
' "V",   ..-. , 00010001, Stelle 17, ASCII 86
' "W",    .-- , 00001011, Stelle 11, ASCII 87
' "X",   -..- , 00011001, Stelle 25, ASCII 88
' "Y",   -.-- , 00011011, Stelle 27, ASCII 89
' "Z",   --.. , 00011100, Stelle 28, ASCII 90
